Index: trunk/src/defs/class_id.h
===================================================================
--- trunk/src/defs/class_id.h	(revision 8527)
+++ trunk/src/defs/class_id.h	(revision 8619)
@@ -287,4 +287,5 @@
   CL_TEXT                       =    0x00804000,
   CL_MULTI_LINE_TEXT            =    0x00000840,
+  CL_LIMITED_WIDTH_TEXT         =    0x00000841,
 
   // Texutres.
@@ -362,4 +363,5 @@
   CL_GLGUI_TEXTFIELD            =    0x00000b61,
   CL_GLGUI_IMAGE                =    0x00000b70,
+  CL_GLGUI_TABLE                =    0x00000b71,
 
   CL_GLGUI_NOTIFIER             =    0x00000b80,
Index: trunk/src/lib/event/event_handler.cc
===================================================================
--- trunk/src/lib/event/event_handler.cc	(revision 8527)
+++ trunk/src/lib/event/event_handler.cc	(revision 8619)
@@ -355,5 +355,5 @@
   else
   {
-    SDL_WM_GrabInput(SDL_GRAB_ON);
+    //SDL_WM_GrabInput(SDL_GRAB_ON);
     SDL_ShowCursor(SDL_DISABLE);
   }
Index: trunk/src/lib/graphics/Makefile.am
===================================================================
--- trunk/src/lib/graphics/Makefile.am	(revision 8527)
+++ trunk/src/lib/graphics/Makefile.am	(revision 8619)
@@ -4,28 +4,30 @@
 noinst_LIBRARIES = libORXgraphics.a
 
-libORXgraphics_a_SOURCES = graphics_engine.cc \
-			   light.cc \
-			   shader.cc \
-			   \
-			   render2D/render_2d.cc \
-			   render2D/element_2d.cc \
-			   render2D/image_plane.cc \
-			   \
-			   text_engine/text_engine.cc \
-			   text_engine/text.cc \
-			   text_engine/multi_line_text.cc \
-			   text_engine/font.cc \
-			   \
-			   effects/graphics_effect.cc \
-			   effects/atmospheric_engine.cc \
-			   effects/weather_effect.cc \
-			   effects/sun_effect.cc \
-			   effects/fog_effect.cc \
-			   effects/volfog_effect.cc \
-			   effects/rain_effect.cc \
-			   effects/snow_effect.cc \
-			   effects/cloud_effect.cc \
-			   effects/lightening_effect.cc \
-			   effects/lense_flare.cc
+libORXgraphics_a_SOURCES = \
+		graphics_engine.cc \
+		light.cc \
+		shader.cc \
+		\
+		render2D/render_2d.cc \
+		render2D/element_2d.cc \
+		render2D/image_plane.cc \
+		\
+		text_engine/text_engine.cc \
+		text_engine/text.cc \
+		text_engine/multi_line_text.cc \
+		text_engine/limited_width_text.cc \
+		text_engine/font.cc \
+		\
+		effects/graphics_effect.cc \
+		effects/atmospheric_engine.cc \
+		effects/weather_effect.cc \
+		effects/sun_effect.cc \
+		effects/fog_effect.cc \
+		effects/volfog_effect.cc \
+		effects/rain_effect.cc \
+		effects/snow_effect.cc \
+		effects/cloud_effect.cc \
+		effects/lightening_effect.cc \
+		effects/lense_flare.cc
 
 noinst_HEADERS = graphics_engine.h \
@@ -40,4 +42,5 @@
 		 text_engine/text.h \
 		 text_engine/multi_line_text.h \
+		 text_engine/limited_width_text.h \
 		 text_engine/font.h \
 		 text_engine/default_font.xpm \
Index: trunk/src/lib/graphics/effects/lense_flare.cc
===================================================================
--- trunk/src/lib/graphics/effects/lense_flare.cc	(revision 8527)
+++ trunk/src/lib/graphics/effects/lense_flare.cc	(revision 8619)
@@ -47,5 +47,4 @@
     this->setClassID(CL_LENSE_FLARE, "LenseFlare");
 
-    this->flareMatrix = new float[14];
     /*          length                      image scale */
     this->flareMatrix[0] = 1.0f;
Index: trunk/src/lib/graphics/effects/lense_flare.h
===================================================================
--- trunk/src/lib/graphics/effects/lense_flare.h	(revision 8527)
+++ trunk/src/lib/graphics/effects/lense_flare.h	(revision 8619)
@@ -51,5 +51,5 @@
     bool                     bVisible;          //!< Checks visibility
     Light*                   lightSource;        //!< reference to the sun (or primary light source)
-    std::vector<ImagePlane*>  flares;             //!< the flares array
+    std::vector<ImagePlane*> flares;             //!< the flares array
 
     Vector2D                 flareVector;        //!< the axis to draw the flares on
@@ -57,5 +57,5 @@
     Vector2D                 screenCenter;       //!< the vector marking the center of the screen
 
-    float*                   flareMatrix;
+    float                    flareMatrix[14];
     Plane                    frustumPlane;       //!< plane that marks the view frustum
 };
Index: trunk/src/lib/graphics/importer/material.cc
===================================================================
--- trunk/src/lib/graphics/importer/material.cc	(revision 8527)
+++ trunk/src/lib/graphics/importer/material.cc	(revision 8619)
@@ -22,4 +22,7 @@
 #include "debug.h"
 #include "compiler.h"
+
+#include "loading/load_param.h"
+
 #include "util/loading/resource_manager.h"
 
@@ -47,4 +50,37 @@
 }
 
+Material& Material::operator=(const Material& material)
+{
+  this->illumModel = material.illumModel;
+  this->diffuse = material.diffuse;
+  this->specular = material.specular;
+  this->ambient = material.ambient;
+  this->shininess = material.shininess;
+
+  this->textures = material.textures;
+  this->sFactor = material.sFactor;
+  this->tFactor = material.tFactor;
+  this->setName(material.getName());
+
+  return *this;
+}
+
+
+
+void Material::loadParams(const TiXmlElement* root)
+{
+  LoadParam(root, "illum", this, Material, setIllum);
+
+  LoadParam(root, "diffuse-color", this, Material , setDiffuse);
+  LoadParam(root, "ambient-color", this, Material , setAmbient);
+  LoadParam(root, "specular-color", this, Material , setSpecular);
+  LoadParam(root, "transparency", this, Material , setTransparency);
+
+  LoadParam(root, "tex", this, Material, setDiffuseMap);
+  LoadParam(root, "blendfunc", this, Material, setBlendFuncS)
+      .defaultValues("ZERO", "ZERO");
+}
+
+
 /**
  * @brief deletes a Material
@@ -65,16 +101,4 @@
 
 const Material* Material::selectedMaterial = NULL;
-
-const GLenum Material::glTextureArbs[] =
-{
-  GL_TEXTURE0,
-  GL_TEXTURE1,
-  GL_TEXTURE2,
-  GL_TEXTURE3,
-  GL_TEXTURE4,
-  GL_TEXTURE5,
-  GL_TEXTURE6,
-  GL_TEXTURE7
-};
 
 
@@ -104,19 +128,19 @@
  * @brief sets the material with which the following Faces will be painted
  */
-  bool Material::select() const
+bool Material::select() const
 {
   if (unlikely(this == Material::selectedMaterial))
-      return true;
-
-/// !!  HACK !!! FIX THIS IN MODEL ///
+    return true;
+
+  /// !!  HACK !!! FIX THIS IN MODEL ///
   else if (likely(Material::selectedMaterial != NULL))
   {
-  Material::unselect();
-//     for(unsigned int i = 0; i < Material::selectedMaterial->textures.size(); ++i)
-//     {
-//         glActiveTexture(Material::glTextureArbs[i]);
-//         glBindTexture(GL_TEXTURE_2D, 0);
-//         glDisable(GL_TEXTURE_2D);
-//     }
+    Material::unselect();
+    //     for(unsigned int i = 0; i < Material::selectedMaterial->textures.size(); ++i)
+    //     {
+    //         glActiveTexture(Material::glTextureArbs[i]);
+    //         glBindTexture(GL_TEXTURE_2D, 0);
+    //         glDisable(GL_TEXTURE_2D);
+    //     }
   }
 
@@ -125,11 +149,11 @@
     for(unsigned int i = 0; i < Material::selectedMaterial->textures.size(); ++i)
     {
-        glActiveTexture(Material::glTextureArbs[i]);
-        //glBindTexture(GL_TEXTURE_2D, 0);
-        glDisable(GL_TEXTURE_2D);
+      glActiveTexture(Material::glTextureArbs[i]);
+      //glBindTexture(GL_TEXTURE_2D, 0);
+      glDisable(GL_TEXTURE_2D);
     }
   }
 
-    // setting diffuse color
+  // setting diffuse color
   glColor4f (diffuse.r(), diffuse.g(), diffuse.b(), diffuse.a());
   // setting ambient color
@@ -161,11 +185,11 @@
   for(unsigned int i = 0; i < this->textures.size(); ++i)
   {
-      glActiveTexture(Material::glTextureArbs[i]);
-      glEnable(GL_TEXTURE_2D);
-      if(this->textures[i].hasAlpha())
-      {
-        glEnable(GL_BLEND);
-      }
-      glBindTexture(GL_TEXTURE_2D, this->textures[i].getTexture());
+    glActiveTexture(Material::glTextureArbs[i]);
+    glEnable(GL_TEXTURE_2D);
+    if(this->textures[i].hasAlpha())
+    {
+      glEnable(GL_BLEND);
+    }
+    glBindTexture(GL_TEXTURE_2D, this->textures[i].getTexture());
   }
   Material::selectedMaterial = this;
@@ -179,10 +203,10 @@
 {
   Material::selectedMaterial = NULL;
-    for(unsigned int i = 0; i < 8; ++i)
-    {
-        glActiveTexture(Material::glTextureArbs[i]);
-        glBindTexture(GL_TEXTURE_2D, 0);
-        glDisable(GL_TEXTURE_2D);
-    }
+  for(unsigned int i = 0; i < 8; ++i)
+  {
+    glActiveTexture(Material::glTextureArbs[i]);
+    glBindTexture(GL_TEXTURE_2D, 0);
+    glDisable(GL_TEXTURE_2D);
+  }
 }
 
@@ -252,4 +276,16 @@
   this->diffuse.a() = trans;
 }
+
+/**
+ * @brief sets the Blend-Function Parameters
+ * @param sFactor the Source Parameter.
+ * @param tFactor the Desitnation Parameter.
+ */
+void Material::setBlendFuncS(const std::string& sFactor, const std::string& tFactor)
+{
+  this->setBlendFunc(Material::stringToBlendFunc(sFactor), Material::stringToBlendFunc(tFactor));
+}
+
+
 
 /**
@@ -354,6 +390,6 @@
   // HACK
   glActiveTexture(textureNumber);
-   glEnable(GL_TEXTURE_2D);
-   glBindTexture(GL_TEXTURE_2D, this->textures[textureNumber].getTexture());
+  glEnable(GL_TEXTURE_2D);
+  glBindTexture(GL_TEXTURE_2D, this->textures[textureNumber].getTexture());
   glCopyTexSubImage2D(target, level, xoffset, yoffset, x, y, width, height);
 
@@ -387,6 +423,5 @@
  */
 void Material::setBump(const std::string& bump)
-{
-}
+{}
 
 
@@ -400,2 +435,69 @@
   return maxTexUnits;
 }
+
+const GLenum Material::glTextureArbs[] =
+{
+  GL_TEXTURE0,
+  GL_TEXTURE1,
+  GL_TEXTURE2,
+  GL_TEXTURE3,
+  GL_TEXTURE4,
+  GL_TEXTURE5,
+  GL_TEXTURE6,
+  GL_TEXTURE7
+};
+
+
+/**
+ * @param blendFunc the Enumerator to convert to a String.
+ * @returns the matching String if found
+ */
+const std::string& Material::blendFuncToString(GLenum blendFunc)
+{
+  for (unsigned int i = 0; i < 9; ++i)
+    if (blendFunc == Material::glBlendFuncParams[i])
+      return Material::blendFuncNames[i];
+  PRINTF(2)("Supplied an Invalid Enumerator to blendfunc %d\n", blendFunc);
+  return Material::blendFuncNames[0];
+}
+
+/**
+ * @param blendFuncString the String to convert into a gl-enumeration
+ * @returns the matching GL-enumeration if found.
+ */
+GLenum Material::stringToBlendFunc(const std::string& blendFuncString)
+{
+  for (unsigned int i = 0; i < 9; ++i)
+    if (blendFuncString == Material::blendFuncNames[i])
+      return Material::glBlendFuncParams[i];
+  PRINTF(2)("BlendFunction %s not recognized using %s\n", blendFuncString.c_str(), Material::blendFuncNames[0].c_str());
+  return Material::glBlendFuncParams[0];
+}
+
+
+const GLenum Material::glBlendFuncParams[] =
+  {
+    GL_ZERO,
+    GL_ONE,
+    GL_DST_COLOR,
+    GL_ONE_MINUS_DST_COLOR,
+    GL_SRC_ALPHA,
+    GL_ONE_MINUS_SRC_ALPHA,
+    GL_DST_ALPHA,
+    GL_ONE_MINUS_DST_ALPHA,
+    GL_SRC_ALPHA_SATURATE
+  };
+
+const std::string Material::blendFuncNames[] =
+  {
+    "ZERO",
+    "ONE",
+    "DST_COLOR",
+    "ONE_MINUS_DST_COLOR",
+    "SRC_ALPHA",
+    "ONE_MINUS_SRC_ALPHA",
+    "DST_ALPHA",
+    "ONE_MINUS_DST_ALPHA",
+    "SRC_ALPHA_SATURATE"
+
+  };
Index: trunk/src/lib/graphics/importer/material.h
===================================================================
--- trunk/src/lib/graphics/importer/material.h	(revision 8527)
+++ trunk/src/lib/graphics/importer/material.h	(revision 8619)
@@ -24,60 +24,74 @@
 class Material : public BaseObject
 {
-  public:
-    Material (const std::string& mtlName = "");
-    virtual ~Material ();
+public:
+  Material (const std::string& mtlName = "");
+  virtual ~Material ();
 
-    Material& operator=(const Material& material);
+  void loadParams(const TiXmlElement* root);
 
-    bool select () const;
-    bool activateTextureUnit(unsigned int textureNumber);
-    static void unselect();
+  Material& operator=(const Material& material);
 
-    void setIllum (int illum);
-    int getIllumModel() const { return this->illumModel; };
+  bool select () const;
+  bool activateTextureUnit(unsigned int textureNumber);
+  static void unselect();
 
-    void setDiffuse (float r, float g, float b);
-    void setDiffuseColor(const Color& diffuseColor) { this->diffuse = diffuseColor; };
-    void setAmbient (float r, float g, float b);
-    void setSpecular (float r, float g, float b);
-    void setShininess (float shini);
-    void setTransparency (float trans);
-    void setBlendFunc(GLenum sFactor, GLenum tFactor) { this->sFactor = sFactor; this->tFactor = tFactor; };
+  void setIllum (int illum);
+  int getIllumModel() const { return this->illumModel; };
 
-    const Color& getDiffuseColor() const { return diffuse; };
+  void setDiffuse (float r, float g, float b);
+  void setDiffuseColor(const Color& diffuseColor) { this->diffuse = diffuseColor; };
+  void setAmbient (float r, float g, float b);
+  void setSpecular (float r, float g, float b);
+  void setShininess (float shini);
+  void setTransparency (float trans);
+  void setBlendFunc(GLenum sFactor, GLenum tFactor) { this->sFactor = sFactor; this->tFactor = tFactor; };
+  void setBlendFuncS(const std::string& sFactor, const std::string& tFactor);
 
-    // MAPPING //
-    void setDiffuseMap(const Texture& texture, unsigned int textureNumber = 0);
-    void setDiffuseMap(const std::string& dMap, GLenum target = GL_TEXTURE_2D, unsigned int textureNumber = 0);
-    void setSDLDiffuseMap(SDL_Surface *surface, GLenum target = GL_TEXTURE_2D, unsigned int textureNumber = 0);
-    void renderToTexture(unsigned int textureNumber, GLenum target, GLint level, GLint xoffset, GLint yoffset, GLint x, GLint y, GLsizei width, GLsizei height);
+  Color& diffuseColor() { return diffuse; };
+  const Color& diffuseColor() const { return diffuse; };
 
-    void setAmbientMap(const std::string& aMap, GLenum target = GL_TEXTURE_2D);
-    void setSpecularMap(const std::string& sMap, GLenum target = GL_TEXTURE_2D);
-    void setBump(const std::string& bump);
-    GLuint getDiffuseTexture(unsigned int i = 0) const { return (this->textures.size() > i)? this->textures[i].getTexture() : 0; };
+  // MAPPING //
+  void setDiffuseMap(const Texture& texture, unsigned int textureNumber = 0);
+  void setDiffuseMap(const std::string& dMap, GLenum target = GL_TEXTURE_2D, unsigned int textureNumber = 0);
+  void setSDLDiffuseMap(SDL_Surface *surface, GLenum target = GL_TEXTURE_2D, unsigned int textureNumber = 0);
+  void renderToTexture(unsigned int textureNumber, GLenum target, GLint level, GLint xoffset, GLint yoffset, GLint x, GLint y, GLsizei width, GLsizei height);
 
-    static void addTexturePath(const std::string& pathName);
+  void setAmbientMap(const std::string& aMap, GLenum target = GL_TEXTURE_2D);
+  void setSpecularMap(const std::string& sMap, GLenum target = GL_TEXTURE_2D);
+  void setBump(const std::string& bump);
 
-  public:
-    static const GLenum glTextureArbs[];  //!< The Texture ARB's
+  GLuint diffuseTextureID(unsigned int i = 0) const { return (this->textures.size() > i)? this->textures[i].getTexture() : 0; };
 
-    static unsigned int getMaxTextureUnits();
+  const Texture& diffuseTexture(unsigned int i = 0) const { return this->textures[i]; };
 
-  private:
-    static const Material* selectedMaterial; //!< The currently selected material.
+  static void addTexturePath(const std::string& pathName);
 
-    int              illumModel;       //!< The IlluminationModel is either flat or smooth.
-    Color            diffuse;          //!< The diffuse color of the Material. (also transparency.)
-    Color            ambient;          //!< The ambient color of the Material.
-    Color            specular;         //!< The specular color of the Material.
-    float            shininess;        //!< The shininess of the Material.
-    GLenum           sFactor;          //!< The Blending Factor for the Source.
-    GLenum           tFactor;          //!< The Blending Factor for the Destination.
+  const std::string& blendFuncToString(GLenum blendFunc);
+  GLenum stringToBlendFunc(const std::string& blendFuncString);
 
-    std::vector<Texture> textures;     //!< An Array of Textures.
 
-    Texture*         ambientTexture;   //!< The ambient texture of the Material.
-    Texture*         specularTexture;  //!< The specular texture of the Material.
+public:
+  static const GLenum glTextureArbs[];  //!< The Texture ARB's
+
+  static const GLenum glBlendFuncParams[];
+  static const std::string blendFuncNames[];
+
+  static unsigned int getMaxTextureUnits();
+
+private:
+  static const Material* selectedMaterial; //!< The currently selected material.
+
+  int              illumModel;       //!< The IlluminationModel is either flat or smooth.
+  Color            diffuse;          //!< The diffuse color of the Material. (also transparency.)
+  Color            ambient;          //!< The ambient color of the Material.
+  Color            specular;         //!< The specular color of the Material.
+  float            shininess;        //!< The shininess of the Material.
+  GLenum           sFactor;          //!< The Blending Factor for the Source.
+  GLenum           tFactor;          //!< The Blending Factor for the Destination.
+
+  std::vector<Texture> textures;     //!< An Array of Textures.
+
+  Texture*         ambientTexture;   //!< The ambient texture of the Material.
+  Texture*         specularTexture;  //!< The specular texture of the Material.
 };
 
Index: trunk/src/lib/graphics/importer/texture_sequence.cc
===================================================================
--- trunk/src/lib/graphics/importer/texture_sequence.cc	(revision 8527)
+++ trunk/src/lib/graphics/importer/texture_sequence.cc	(revision 8619)
@@ -180,5 +180,5 @@
   }
   bool success = this->addFrame(addSurface);
-  delete addSurface;
+  SDL_FreeSurface(addSurface);
 
   return success;
Index: trunk/src/lib/graphics/text_engine/limited_width_text.cc
===================================================================
--- trunk/src/lib/graphics/text_engine/limited_width_text.cc	(revision 8619)
+++ trunk/src/lib/graphics/text_engine/limited_width_text.cc	(revision 8619)
@@ -0,0 +1,175 @@
+/*
+   orxonox - the future of 3D-vertical-scrollers
+
+   Copyright (C) 2004 orx
+
+   This program is free software; you can redistribute it and/or modify
+   it under the terms of the GNU General Public License as published by
+   the Free Software Foundation; either version 2, or (at your option)
+   any later version.
+
+   ### File Specific:
+   main-programmer: Benjamin Grauer
+   co-programmer: ...
+*/
+
+#define DEBUG_SPECIAL_MODULE DEBUG_MODULE_GRAPHICS
+
+#include "limited_width_text.h"
+#include "font.h"
+
+/**
+ * @brief creates a new Text Element
+ * @param fontFile the Font to render this text in
+ * @param type The renderType to display this font in
+ */
+LimitedWidthText::LimitedWidthText(const std::string& fontFile, unsigned int textSize, float lineWidth, DotsPosition dotsPosition)
+    : Text(fontFile, textSize)
+{
+  this->setClassID(CL_LIMITED_WIDTH_TEXT, "LimitedWidthText");
+
+  this->_dotsPosition = End;
+  this->setLineWidth(lineWidth);
+}
+
+/**
+ * @brief sets the maximum Line width
+ * @param lineWidth the maximum lineWidth.
+ */
+void LimitedWidthText::setLineWidth(float lineWidth)
+{
+  this->_lineWidth = lineWidth;
+  this->setupTextWidth();
+}
+
+/**
+ * @brief sets the Dots Position
+ * @param dotsPosition the Position of the Dots
+ */
+void LimitedWidthText::setDotsPosition(DotsPosition dotsPosition)
+{
+  this->_dotsPosition = dotsPosition;
+  this->setupTextWidth();
+}
+
+
+/**
+ * @brief draws the Text
+ */
+void LimitedWidthText::draw() const
+{
+  if (unlikely(this->_dotedText.empty()))
+    return;
+  glPushMatrix();
+  glPushAttrib(GL_ENABLE_BIT);
+  // transform for alignment.
+  if (this->getAlignment() == TEXT_ALIGN_RIGHT)
+    glTranslatef(-this->getSizeX2D(), 0, 0);
+  else if (this->getAlignment() == TEXT_ALIGN_CENTER || this->getAlignment() == TEXT_ALIGN_SCREEN_CENTER)
+    glTranslatef(-this->getSizeX2D()/2, 0, 0);
+
+  // drawing this Text.
+  // setting the Blending effects
+  glColor4fv(&this->color()[0]);
+
+
+  glActiveTexture(GL_TEXTURE0);
+
+  glEnable(GL_BLEND);
+  glEnable(GL_TEXTURE_2D);
+  glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);
+  glTexEnvi(GL_TEXTURE_ENV, GL_TEXTURE_ENV_COLOR, GL_MODULATE );
+
+  glBindTexture(GL_TEXTURE_2D, this->font()->getTexture());
+  glTranslatef(getAbsCoor2D().x, getAbsCoor2D().y, 0);
+  glRotatef(this->getAbsDir2D(), 0, 0, 1);
+
+  Glyph* tmpGlyph;
+  float posX = 0.0f;
+  glBegin(GL_QUADS);
+  for (unsigned int i = 0; i < this->_dotedText.size(); i++)
+  {
+    if(likely((tmpGlyph = this->font()->getGlyphArray()[this->_dotedText[i]]) != NULL))
+    {
+      glTexCoord2f(tmpGlyph->texCoord[1], tmpGlyph->texCoord[2]);
+      glVertex2d(posX+tmpGlyph->maxX*this->size(), 0);
+
+      glTexCoord2f(tmpGlyph->texCoord[1], tmpGlyph->texCoord[3]);
+      glVertex2d(posX+tmpGlyph->maxX*this->size(), this->size());
+
+      glTexCoord2f(tmpGlyph->texCoord[0], tmpGlyph->texCoord[3]);
+      glVertex2d(posX+tmpGlyph->minX*this->size(), this->size());
+
+      glTexCoord2f(tmpGlyph->texCoord[0], tmpGlyph->texCoord[2]);
+      glVertex2d(posX+tmpGlyph->minX*this->size(), 0);
+
+      posX += tmpGlyph->advance * this->size();
+    }
+  }
+  glEnd();
+  glPopAttrib();
+  glPopMatrix();
+}
+
+
+/**
+ * @brief setting up the Text-Width if DYNAMIC
+ */
+void LimitedWidthText::setupTextWidth()
+{
+  float dotsSize = this->font()->getGlyphArray()[46]->advance * 3.0;
+
+  float width = 0.0f;
+  float maxWidth = this->_lineWidth / this->size();
+
+  this->_dotedText = this->text();
+
+  switch (this->_dotsPosition)
+  {
+    case End:
+      for (unsigned int i = 0; i < this->text().size(); i++)
+      {
+        if (width + dotsSize > maxWidth )
+        {
+          this->_dotedText = this->text().substr(0, i) + "...";
+          if (i > 0)
+            width -= this->font()->getGlyphArray()[this->text()[i-1]]->advance;
+          width += dotsSize;
+          break;
+        }
+        // Advance the Text.
+        if(this->font()->getGlyphArray()[this->text()[i]] != NULL)
+          width += this->font()->getGlyphArray()[this->text()[i]]->advance;
+      }
+      break;
+
+    case Begin:
+      int i = text().size() -1;
+      for (; i >= 0; --i)
+      {
+        if (width + dotsSize > maxWidth )
+        {
+          this->_dotedText = std::string("...") + this->text().substr(i);
+          if (i + 1 < (int)text().size() )
+            width -= this->font()->getGlyphArray()[this->text()[i+1]]->advance;
+          width += dotsSize;
+          break;
+        }
+        // Advance the Text.
+        if(this->font()->getGlyphArray()[this->text()[i]] != NULL)
+          width += this->font()->getGlyphArray()[this->text()[i]]->advance;
+      }
+      break;
+  }
+
+  printf("%f %s\n", width, _dotedText.c_str());
+  this->setSizeX2D(width * this->size());
+}
+
+/**
+ * @brief print out some nice debug output
+ */
+void LimitedWidthText::debug() const
+{
+  printf("Debug %s::%s \n", this->getClassName(), this->getName() );
+}
Index: trunk/src/lib/graphics/text_engine/limited_width_text.h
===================================================================
--- trunk/src/lib/graphics/text_engine/limited_width_text.h	(revision 8619)
+++ trunk/src/lib/graphics/text_engine/limited_width_text.h	(revision 8619)
@@ -0,0 +1,51 @@
+/*!
+ * @file limited_width_text.h
+ * @brief Definition of a text Class, that is able to render text.
+ */
+
+#ifndef _LIMITED_WIDTH_TEXT_H
+#define _LIMITED_WIDTH_TEXT_H
+
+#include "text.h"
+
+#include <vector>
+
+//! Represents one textElement.
+class LimitedWidthText : public Text
+{
+  public:
+    typedef enum {
+      Begin,
+      End,
+    } DotsPosition;
+
+
+  public:
+    LimitedWidthText(const std::string& fontFile = "", unsigned int fontSize = TEXT_DEFAULT_SIZE, float lineWidth = 100.0, DotsPosition dotsPosition = Begin);
+
+    // Setup:
+    void setLineWidth(float lineWidth);
+    void setDotsPosition(DotsPosition dotsPosition);
+
+    // Retrieve:
+    /** @returns the LineWidth (maximum distance from the left to the right */
+    inline float lineWidth() const { return this->_lineWidth; };
+    /** @returns the dots position. */
+    inline float dotsPosition() const { return this->_dotsPosition; };
+
+    virtual void draw() const;
+
+    void debug() const;
+
+  protected:
+    virtual void setupTextWidth();
+
+  private:
+    std::string                _dotedText;
+
+    DotsPosition               _dotsPosition;
+    float                      _lineWidth;
+    unsigned int               _lineEnds;
+};
+
+#endif /* _LIMITED_WIDTH_TEXT_H */
Index: trunk/src/lib/graphics/text_engine/multi_line_text.cc
===================================================================
--- trunk/src/lib/graphics/text_engine/multi_line_text.cc	(revision 8527)
+++ trunk/src/lib/graphics/text_engine/multi_line_text.cc	(revision 8619)
@@ -61,5 +61,5 @@
 void MultiLineText::draw() const
 {
-  if (unlikely(this->getText().empty()))
+  if (unlikely(this->text().empty()))
     return;
   glPushMatrix();
@@ -76,5 +76,5 @@
   glActiveTexture(GL_TEXTURE0);
 
-  glColor4fv(&this->getColor()[0]);
+  glColor4fv(&this->color()[0]);
   glEnable(GL_BLEND);
   glEnable(GL_TEXTURE_2D);
@@ -82,5 +82,5 @@
   glTexEnvi(GL_TEXTURE_ENV, GL_TEXTURE_ENV_COLOR, GL_MODULATE );
 
-  glBindTexture(GL_TEXTURE_2D, this->getFont()->getTexture());
+  glBindTexture(GL_TEXTURE_2D, this->font()->getTexture());
   glTranslatef(this->getAbsCoor2D().x, this->getAbsCoor2D().y, 0);
   glRotatef(this->getAbsDir2D(), 0, 0, 1);
@@ -92,5 +92,5 @@
 
   glBegin(GL_QUADS);
-  for (unsigned int i = 0; i < this->getText().size(); ++i)
+  for (unsigned int i = 0; i < this->text().size(); ++i)
   {
     if (unlikely(this->lineEnds.size() > lineNumber && i == this->lineEnds[lineNumber]))
@@ -99,22 +99,22 @@
       ++lineNumber;
       posX = 0.0f;
-      posY += this->lineSpacing + this->getSize(); //this->getFont()->getMaxHeight();
+      posY += this->lineSpacing + this->size(); //this->font()->getMaxHeight();
     }
 
-    if(likely((tmpGlyph = this->getFont()->getGlyphArray()[this->getText()[i]]) != NULL))
+    if(likely((tmpGlyph = this->font()->getGlyphArray()[this->text()[i]]) != NULL))
     {
       glTexCoord2f(tmpGlyph->texCoord[1], tmpGlyph->texCoord[2]);
-      glVertex2d(posX+tmpGlyph->maxX*this->getSize(), posY);
+      glVertex2d(posX+tmpGlyph->maxX*this->size(), posY);
 
       glTexCoord2f(tmpGlyph->texCoord[1], tmpGlyph->texCoord[3]);
-      glVertex2d(posX+tmpGlyph->maxX*this->getSize(), posY + this->getSize());
+      glVertex2d(posX+tmpGlyph->maxX*this->size(), posY + this->size());
 
       glTexCoord2f(tmpGlyph->texCoord[0], tmpGlyph->texCoord[3]);
-      glVertex2d(posX+tmpGlyph->minX*this->getSize(), posY+ this->getSize());
+      glVertex2d(posX+tmpGlyph->minX*this->size(), posY+ this->size());
 
       glTexCoord2f(tmpGlyph->texCoord[0], tmpGlyph->texCoord[2]);
-      glVertex2d(posX+tmpGlyph->minX*this->getSize(), posY);
+      glVertex2d(posX+tmpGlyph->minX*this->size(), posY);
 
-      posX += tmpGlyph->advance * this->getSize();
+      posX += tmpGlyph->advance * this->size();
     }
   }
@@ -132,14 +132,14 @@
   this->lineEnds.clear();
   float width = 0.0f;
-  float maxWidth = this->lineWidth / this->getSize();
+  float maxWidth = this->lineWidth / this->size();
 
-  for (unsigned int i = 0; i < this->getText().size(); i++)
+  for (unsigned int i = 0; i < this->text().size(); i++)
   {
-    if (width > maxWidth || this->getText()[i] == '\n')
+    if (width > maxWidth || this->text()[i] == '\n')
     {
       if (likely(i > 0))
       {
         this->lineEnds.push_back( i -1 );
-        width = this->getFont()->getGlyphArray()[this->getText()[i-1]]->advance;
+        width = this->font()->getGlyphArray()[this->text()[i-1]]->advance;
       }
       else
@@ -148,9 +148,9 @@
 
     // Advance the Text.
-    if(this->getFont()->getGlyphArray()[this->getText()[i]] != NULL)
-      width += this->getFont()->getGlyphArray()[this->getText()[i]]->advance;
+    if(this->font()->getGlyphArray()[this->text()[i]] != NULL)
+      width += this->font()->getGlyphArray()[this->text()[i]]->advance;
   }
   this->lineCount = lineEnds.size() + 1;
-  this->setSizeY2D((this->lineEnds.size()+1) * (this->lineSpacing + this->getFont()->getMaxHeight()));
+  this->setSizeY2D((this->lineEnds.size()+1) * (this->lineSpacing + this->font()->getMaxHeight()));
 }
 
@@ -162,5 +162,5 @@
  printf("Debug %s::%s: %d lines\n", this->getClassName(), this->getName(), this->getLineCount());
 
- std::string tmpText = this->getText();
+ std::string tmpText = this->text();
  std::vector<unsigned int> ends = this->lineEnds;
  ends.push_back(tmpText.size());
